/* from Quintus Prolog library */
long ctr[32];   /* These counters are visible to other C code */

#define CTR_INC 0
#define CTR_DEC 1
#define CTR_SET 2

long ctr_val(Counter)
     int Counter;
{
  return ctr[Counter&31];
}

void ctr_op2(Counter, NewValue, Op)
     int Counter;
     long NewValue;
     int Op;
{
  switch (Op) {
  case CTR_INC: ctr[Counter&31] += NewValue; break;
  case CTR_DEC: ctr[Counter&31] -= NewValue; break;
  case CTR_SET: ctr[Counter&31]  = NewValue; break;
  }
}

long ctr_op3(Counter, NewValue, Op)
     int Counter;
     long NewValue;
     int Op;
{
  register long *p = &ctr[Counter&31];
  register long OldValue = *p;

  switch (Op) {
  case CTR_INC: *p += NewValue; break;
  case CTR_DEC: *p -= NewValue; break;
  case CTR_SET: *p  = NewValue; break;
  }
  return OldValue;
}
